<?PHP /* $Id$ */

	/**
	* module jstats_visitors_by_country
	* @package mod_jstats_visitors_by_country
	* @copyright 2008 JoomlaStats Team
	* @license http://www.gnu.org/copyleft/gpl.html. GNU Public License
	* @version $Revision: 2.4 $
	* @author JoomlaStats Team <www.JoomlaStats.org>
	*
	* Mod. BR - Fernando Soares  -  http://www.fernandosoares.com.br - Janeiro/2008
	*

	*/
	
	//ensure this file is being included by a parent file
	defined('_VALID_MOS') or die ('Direct access to this location is not allowed.');

	global $mosConfig_offset;		// get global hour difference
	
	$top = $params->get('top');
	$Visitors = $params->get('visitors');
	$ShowToolTips = $params->get('showtooltips');
	$ShowHeader = $params->get('showheader');
	$ShowNrInHeader = $params->get('shownrinheader');	
	$ShowVisits = $params->get('showvisits');
	$ShowFooter = $params->get('showfooter');
	$FooterText1 = $params->get('footertext1');
	$FooterText2 = $params->get('footertext2');
	

	$append	= (($top=='') || ($ShowNrInHeader==0)) ? "" : " (".$top." primeiros)";	

	$content .= '<table cellspacing="0" width="100%">';	
	$content .= '<tr><td colspan="3">';	
	
	if ($top != 0)
		switch ($Visitors)
		{
			case "today":
				if ($ShowHeader)
					$content .= '<span class="small">Hoje'.$append.'</span>';
				$sql  = "SELECT count(*) AS numbers,#__jstats_ipaddresses.tld,#__jstats_topleveldomains.fullname ";
				$sql .= "FROM #__jstats_ipaddresses LEFT JOIN #__jstats_topleveldomains ON(#__jstats_ipaddresses.tld = #__jstats_topleveldomains.tld) LEFT JOIN #__jstats_visits ON(#__jstats_ipaddresses.id = #__jstats_visits.ip_id) ";
				$sql .= "WHERE ((#__jstats_visits.day = DATE_FORMAT(DATE_ADD(NOW(), INTERVAL $mosConfig_offset HOUR),'%e')) AND (#__jstats_visits.month = DATE_FORMAT(DATE_ADD(NOW(), INTERVAL $mosConfig_offset HOUR),'%c')) AND (#__jstats_visits.year = DATE_FORMAT(DATE_ADD(NOW(), INTERVAL $mosConfig_offset HOUR),'%Y')) AND (#__jstats_ipaddresses.type='1')) ";
				$sql .= "GROUP BY tld ORDER BY numbers DESC, #__jstats_topleveldomains.fullname ASC";
				break;
			case "thisweek":
				if ($ShowHeader)
					$content .= '<span class="small">Esta semana'.$append.'</span>';
				$sql  = "SELECT count(*) AS numbers,#__jstats_ipaddresses.tld,#__jstats_topleveldomains.fullname ";
				$sql .= "FROM #__jstats_ipaddresses LEFT JOIN #__jstats_topleveldomains ON(#__jstats_ipaddresses.tld = #__jstats_topleveldomains.tld) LEFT JOIN #__jstats_visits ON(#__jstats_ipaddresses.id = #__jstats_visits.ip_id) ";
				$sql .= "WHERE (DATE_FORMAT(DATE_ADD(CONCAT(#__jstats_visits.year,'-',#__jstats_visits.month,'-',#__jstats_visits.day), INTERVAL $mosConfig_offset HOUR),'%v') = DATE_FORMAT(NOW(),'%v') AND (#__jstats_visits.year = DATE_FORMAT(DATE_ADD(NOW(), INTERVAL $mosConfig_offset HOUR),'%Y')) AND (#__jstats_ipaddresses.type='1')) ";
				$sql .= "GROUP BY tld ORDER BY numbers DESC, #__jstats_topleveldomains.fullname ASC";
				break;
			case "thismonth":
				if ($ShowHeader)
					$content .= '<span class="small">Este ms'.$append.'</span>';
				$sql  = "SELECT count(*) AS numbers,#__jstats_ipaddresses.tld,#__jstats_topleveldomains.fullname ";
				$sql .= "FROM #__jstats_ipaddresses LEFT JOIN #__jstats_topleveldomains ON(#__jstats_ipaddresses.tld = #__jstats_topleveldomains.tld) LEFT JOIN #__jstats_visits ON(#__jstats_ipaddresses.id = #__jstats_visits.ip_id) ";
				$sql .= "WHERE ((#__jstats_visits.month = DATE_FORMAT(DATE_ADD(NOW(), INTERVAL $mosConfig_offset HOUR),'%c')) AND (#__jstats_visits.year = DATE_FORMAT(DATE_ADD(NOW(), INTERVAL $mosConfig_offset HOUR),'%Y')) AND (#__jstats_ipaddresses.type='1')) ";
				$sql .= "GROUP BY tld ORDER BY numbers DESC, #__jstats_topleveldomains.fullname ASC";
				break;
			default:	// total
				if ($ShowHeader)
					$content .= '<span class="small">Total'.$append.'</span>';
				$sql  = "SELECT count(*) AS numbers,#__jstats_ipaddresses.tld,#__jstats_topleveldomains.fullname ";
				$sql .= "FROM #__jstats_ipaddresses LEFT JOIN #__jstats_topleveldomains ON(#__jstats_ipaddresses.tld = #__jstats_topleveldomains.tld) LEFT JOIN #__jstats_visits ON(#__jstats_ipaddresses.id = #__jstats_visits.ip_id) ";
				$sql .= "WHERE #__jstats_ipaddresses.type='1' ";
				$sql .= "GROUP BY tld ORDER BY numbers DESC, #__jstats_topleveldomains.fullname ASC";
		}
//		$sql .= $limit;	// now we only need to queury the number of items selected		// is it good or not to limit the SQL request?  // if we want to filter out net/unknonw/commercial then we need more rows!

	$content .= '</td></tr>';



	// calculate total tld visits
	$totalnmb = 0;
	$mainframe->_db->setQuery($sql);
	$rs = mysql_query($mainframe->_db->_sql);		
	while ($row = mysql_fetch_array($rs)) 
		$totalnmb += $row['numbers'];
		
	if ($totalnmb != 0)
	{
		$i = $params->get('top') != '' ? $params->get('top') : 0;	// set how many rows we must display
		
		mysql_data_seek($rs,0);		
		while (($row = mysql_fetch_array($rs)) && $i>0) 
		{
			$i--;
			if (!$params->get('shownoncountries') && ($row[1]=='' || $row[1]=='localho' || $row[1]=='unknown' || $row[1]=='local'	
				|| $row[1]=='com' || $row[1]=='net' || $row[1]=='org' || $row[1]=='edu' || $row[1]=='info' 
				|| $row[1]=='mil' || $row[1]=='int' || $row[1]=='arpa'))
			 	continue;
			$content .= '<tr>';
						
			$tooltip = $ShowToolTips ? ' title="'. strtoupper($row[1]) ." $row[2]\"" : "";		

			if ($row[1] == '')
				$content .= "<td align=\"left\"><img src=\"components/com_joomlastats/images/tld/unknown.png\"$tooltip></td>";
			else
				$content .= "<td align=\"left\"><img src=\"components/com_joomlastats/images/tld/".$row[1].".png\"$tooltip></td>";

			$val = round((($row[0]/$totalnmb)*100),0) > 1 ? round((($row[0]/$totalnmb)*100),0) : "< 1.0";
			$content .= "<td align=\"right\" nowrap>&nbsp;$val %</td>";
			$content .= "<td width=\"100%\" align=\"left\" nowrap>&nbsp;$row[2] ";
			if ($params->get('shownrofvisits'))
				$content .= "($row[0])";
			$content .= "</td>";
			
			$content .= '</tr>';
		}	
	}
	
	
	if ($ShowFooter)
	{
		if ($ShowVisits)
		{
			$sql = "SELECT SQL_BIG_RESULT count(*)"
			 	 . " FROM #__jstats_visits LEFT JOIN #__jstats_ipaddresses ON (#__jstats_visits.ip_id=#__jstats_ipaddresses.id)"
			 	 . " WHERE #__jstats_ipaddresses.type=1";
			$database->setQuery($sql);
			$TotalVisits = $database->loadResult();
		}
		
		$sql = "SELECT count(DISTINCT tld) FROM #__jstats_ipaddresses";
		$database->setQuery($sql);
		$TotalCountries = $database->loadResult();			
		
		$content .= '<tr><td colspan="3">';	
		if ($ShowVisits)
			$content .= "$TotalVisits ";
		$content .= "$FooterText1 $TotalCountries $FooterText2</td></tr>";
	}
			
	$content .= '</table>';
?>
